public class ARB{
    public NodoB raiz;
    private static final int BLACK = 1; // Black must be 1
    private static final int RED   = 0;
    public ARB(){
        raiz = null;
    }
    public boolean buscar(int x){
        return buscar(x, raiz);
    }
    private boolean buscar(int x, NodoB nodo){
        if( nodo == null)
            return false;
        else if( nodo.info == x)
            return true;
        else if( nodo.info < x)
            return buscar(x, nodo.der);
        else
            return buscar(x, nodo.izq);
    }
    public void insertar(int x){
        if(!buscar(x)){
            raiz = insertar(x, raiz, false);
            raiz.color = BLACK;
        }
        return;
    }
    private boolean isRed(NodoB nodo){
        if(nodo == null)
            return false;
        if(nodo.color == RED)
            return true;
        return false;
    }
    private NodoB insertar(int x, NodoB nodo, boolean sw){
        if(nodo == null)
            return new NodoB(x,RED);
        if( isRed(nodo.izq) && isRed(nodo.der)){
            nodo.color = RED;
            nodo.izq.color = BLACK;
            nodo.der.color = BLACK;
        }
        if ( x < nodo.info){
            nodo.izq = insertar(x, nodo.izq, false);
            if( isRed(nodo) && isRed(nodo.izq) && sw)
                nodo = rotD(nodo);
            if( isRed(nodo.izq) && isRed(nodo.izq.izq)){
                nodo = rotD(nodo);
                nodo.color = BLACK;
                nodo.der.color = RED;
            }
        }
        else{
            nodo.der = insertar(x, nodo.der, true);
            if( isRed(nodo) && isRed(nodo.der) && !sw)
                nodo = rotI(nodo);
            if( isRed(nodo.der) && isRed(nodo.der.der)){
                nodo = rotI(nodo);
                nodo.color = BLACK;
                nodo.izq.color = RED;
            }
        }
        return nodo;
    }
    private NodoB rotI(NodoB nodo)
    {
        NodoB x =  nodo.der;
        nodo.der = x.izq;
        x.izq = nodo;
        return x;
    }
    private NodoB rotD(NodoB nodo)
    {
        NodoB x = nodo.izq;
        nodo.izq = x.der;
        x.der = nodo;
        return x;
    }       
}